#pragma once

#include "mymat.h"
#include "mcmc.h"

using namespace Threading;
using namespace myLib;
using namespace mcmc_spc;

namespace PoissonExpReg {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// MyForm ̊Tv
	/// </summary>
	public ref class MyForm : public System::Windows::Forms::Form
	{
	public:
		MyForm(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^[ R[hǉ܂
			//
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~MyForm()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Button^  buttonGo;
	protected: 
	private: System::Windows::Forms::Button^  buttonClose;
	private: System::Windows::Forms::OpenFileDialog^  openFileDialog1;
	private: System::Windows::Forms::SaveFileDialog^  saveFileDialog1;

	protected: 

	private:
		/// <summary>
		/// KvȃfUCi[ϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi[ T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^[ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->buttonGo = (gcnew System::Windows::Forms::Button());
			this->buttonClose = (gcnew System::Windows::Forms::Button());
			this->openFileDialog1 = (gcnew System::Windows::Forms::OpenFileDialog());
			this->saveFileDialog1 = (gcnew System::Windows::Forms::SaveFileDialog());
			this->SuspendLayout();
			// 
			// buttonGo
			// 
			this->buttonGo->Location = System::Drawing::Point(37, 97);
			this->buttonGo->Name = L"buttonGo";
			this->buttonGo->Size = System::Drawing::Size(75, 23);
			this->buttonGo->TabIndex = 0;
			this->buttonGo->Text = L"Go";
			this->buttonGo->UseVisualStyleBackColor = true;
			this->buttonGo->Click += gcnew System::EventHandler(this, &MyForm::buttonGo_Click);
			// 
			// buttonClose
			// 
			this->buttonClose->Location = System::Drawing::Point(167, 97);
			this->buttonClose->Name = L"buttonClose";
			this->buttonClose->Size = System::Drawing::Size(75, 23);
			this->buttonClose->TabIndex = 1;
			this->buttonClose->Text = L"Close";
			this->buttonClose->UseVisualStyleBackColor = true;
			this->buttonClose->Click += gcnew System::EventHandler(this, &MyForm::buttonClose_Click);
			// 
			// openFileDialog1
			// 
			this->openFileDialog1->FileName = L"openFileDialog1";
			// 
			// MyForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(284, 262);
			this->Controls->Add(this->buttonClose);
			this->Controls->Add(this->buttonGo);
			this->Name = L"MyForm";
			this->Text = L"MyForm";
			this->ResumeLayout(false);

		}
#pragma endregion
	private: System::Void buttonClose_Click(System::Object^  sender, System::EventArgs^  e) {
				 this->Close();
			 }

			 
	//
	//		pos Ԗڂ̎̕o
	//
	String ^ SeekStr( String ^ str, int pos ){
		String ^ vstr = "";
		array<wchar_t> ^ separator = { ' ', '\t', ',','@','/' };
		array<String ^> ^ ary_str;
		ary_str = str->Split( separator );
		int L = ary_str->Length;
		int ckp = -1;
		int tmpPos = 0;
		do {
			if (ary_str[tmpPos]->Length > 0) ckp++;
			tmpPos++;
		} while ((ckp != pos) && (tmpPos < L) );
		if (ckp == pos) vstr = ary_str[tmpPos-1];

		return vstr;
	}

	double sqr( double v ){
			return v * v;
	}

	//
	//				95% credible intervalimMԁj
	//
	//			rec : ordered record,	
	//			LB : lower 2.5% point,		Median : 50% point,		UB: upper 2.5% point,
	//			Mean : mean
	//
	void CalcCIMedMean( double * rec, int n, double & LB, double & Median, double & UB, double & Mean ){
		LB = rec[int(n * 0.025)];
		Median = rec[int(n * 0.5)];
		UB = rec[int(n * 0.975)];

		double sum = 0.0;
		for (int i = 0; i < n; i++)
			sum += rec[i];
		Mean = sum / n;
	}


	private: System::Void buttonGo_Click(System::Object^  sender, System::EventArgs^  e) {
				openFileDialog1->Title = "̓f[^t@C ?";
				openFileDialog1->Filter = "Text File (*.txt)|*.txt";
				openFileDialog1->FileName = "";
				if (openFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::Cancel) return;

				
				using namespace System::IO;						//   For StreamReader and StreamWriter.

				StreamReader ^ fin = gcnew StreamReader( openFileDialog1->FileName, System::Text::Encoding::GetEncoding("shift-jis") );

				//   ۑpt@C̖O̐ݒ
				saveFileDialog1->Title = "o̓f[^t@C ?";
				saveFileDialog1->Filter = "Text File (*.txt)|*.txt";
				saveFileDialog1->FileName = "";
				if (saveFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::Cancel) return;
				StreamWriter ^fout = gcnew StreamWriter( saveFileDialog1->FileName, false, System::Text::Encoding::GetEncoding( "shift-jis") );

				buttonGo->Enabled = false;

				fout->WriteLine("Data File..." + openFileDialog1->FileName);
				fout->WriteLine();

				do{
					String ^s = fin->ReadLine();
					fout->WriteLine(s);
					if(s->Length > 0)
						if(s[0] == '/') break;
				}while(true);
				int p = int::Parse(fin->ReadLine());	//	Ɨϐ̐
				array<String^>^ aryVLabel = gcnew array<String^>(p);
				for (int i = 0; i < p; i++)
					aryVLabel[i] = fin->ReadLine();
				fout->WriteLine();
				for (int i = 0; i < p; i++)
					fout->WriteLine("X[" + (i+1).ToString() + "] --> " + aryVLabel[i]);
				do{
					String ^s = fin->ReadLine();
					fout->WriteLine(s);
					if(s->Length > 0)
						if(s[0] == '/') break;
				}while(true);
				int N = 0;
				do{
					String ^s = fin->ReadLine();
					if(s->Length > 0)
						if(s[0] == '/') break;
					N++;							//	f[^̐
				}while(true);
				fin->Close();
				fin = gcnew StreamReader( openFileDialog1->FileName, System::Text::Encoding::GetEncoding("shift-jis") );
				double * Y = new double[N];
				double ** X = new double*[N];
				for (int i = 0; i < N; i++)
					X[i] = new double[p];
				do{
					String ^s = fin->ReadLine();
					fout->WriteLine(s);
					if(s->Length > 0)
						if(s[0] == '/') break;
				}while(true);
				do{
					String ^s = fin->ReadLine();
					fout->WriteLine(s);
					if(s->Length > 0)
						if(s[0] == '/') break;
				}while(true);
				for (int i = 0; i < N; i++){
					String ^ s = fin->ReadLine();
					Y[i] = double::Parse(SeekStr(s, 0));
					for (int j = 0; j < p; j++)
						X[i][j] = double::Parse(SeekStr(s, j+1));
				}
				fin->ReadLine();
				fout->WriteLine();
				fout->WriteLine("Data...");
				for (int i = 0; i < N; i++){
					fout->Write(i.ToString()->PadLeft(5) + ": " + Y[i].ToString()->PadLeft(10));
					for (int j = 0; j < p; j++)
						fout->Write(X[i][j].ToString()->PadLeft(5));
					fout->WriteLine();
				}

				myMat matX = ConvToMat( X, N, p );
				myMat XX = matTransp(matX) * matX;
				myMat invXX( p, p );
				int ck_inv = calcInvMat( XX, invXX, p );
				if (ck_inv != 0){
					fout->WriteLine();
					fout->WriteLine("=========================================");
					fout->WriteLine();
					fout->WriteLine("       Rank of X is not full !");
					fin->Close();
					fout->Close();
					MessageBox::Show(saveFileDialog1->FileName + " was saved.");
					this->Close();
				}
				myMat tempY(N, 1);
				for (int i = 0; i < N; i++) tempY[i][0] = Math::Log(Y[i]);
				myMat tempB(p, 1);
				tempB = invXX * matTransp(matX) * tempY;

				fout->WriteLine();
				for (int i = 0; i < p; i++)
					fout->WriteLine("tempB[" + i.ToString() + "] = " + tempB[i][0].ToString());

				double sumB = 0.0, sumBB = 0.0;
				for (int i = 0; i < p; i++){
					sumB += tempB[i][0];
					sumBB += sqr(tempB[i][0]);
				}
				double tempVar = (sumBB / p) - sqr(sumB / p);
				if (tempVar <= 0.0){
					fout->WriteLine();
					fout->WriteLine("Calculated tempVar = " + tempVar.ToString());
					tempVar = 0.0001;
					fout->WriteLine("Replaced value of tempVar = " + tempVar.ToString());
					fout->WriteLine();
				}
				double tempSgmB = Math::Sqrt(tempVar);
				fout->WriteLine();
				fout->WriteLine("tempSgmB = " + tempSgmB.ToString());

				fout->WriteLine();
				int NSimu = 10000;
				double * sgmB = new double[p];
				for (int i = 0; i < p; i++)
					sgmB[i] = tempSgmB / 1000.0;
				double * initB = new double[p];
				for (int i = 0; i < p; i++)
					initB[i] = tempB[i][0];

				do{
					MCMC mcmc;
					RNP2to191  rn;
					mcmc.Init( NSimu, "Testing...", & rn, N, p, Y, X, sgmB, initB );
					
					mcmc.do_mcmc();

					/***
					fout->WriteLine();
					for(int i = 0; i < p; i++)
						fout->WriteLine("countB[" + i.ToString() + "] / NSimu = " + (mcmc.countB[i] / double(NSimu)).ToString());
					fout->WriteLine();
					***/

					int sum_ck = 0;
					for (int i = 0; i < p; i++){
						int ck;
						sgmB[i] *= scale_sgm( mcmc.countB[i] / double(NSimu), ck );
						sum_ck += ck;
					}
					/***
					fout->WriteLine("sum_ck = " + sum_ck.ToString());
					for(int i = 0; i < p; i++)
						fout->WriteLine("New sgmB[" + i.ToString() + "] = " + sgmB[i].ToString());
						***/
					for (int i = 0; i < p; i++){
						double sum = 0.0;
						for (int j = 1; j <= NSimu; j++)
							sum += mcmc.paramB[j][i];
						initB[i] = sum / NSimu;

				//		fout->WriteLine("New initB[" + i.ToString() + "] = " + initB[i].ToString());
					}
					if(sum_ck == 0) break;
				} while(true);

				NSimu = 10000;
				int nmcmc = 4;

				array<MCMC^> ^myMCMC = gcnew array<MCMC^>(nmcmc);
				RNP2to191 ** arry_rn = new RNP2to191*[nmcmc];
				for (int imcmc = 0; imcmc < nmcmc; imcmc++){
					myMCMC[imcmc] = gcnew MCMC();
					arry_rn[imcmc] = new RNP2to191();
					for (int i = 0; i < imcmc; i++)
						arry_rn[imcmc]->Jump2toj(100);
					myMCMC[imcmc]->Init( NSimu, "MCMC-" + imcmc.ToString(), arry_rn[imcmc], N, p, Y, X, sgmB, initB );
				}

				array<ThreadStart^> ^ThStart = gcnew array<ThreadStart^>(nmcmc);
				for (int imcmc = 0; imcmc < nmcmc; imcmc++)
					ThStart[imcmc] = gcnew ThreadStart( myMCMC[imcmc], &MCMC::do_mcmc );

				array<Thread^> ^myThread = gcnew array<Thread^>(nmcmc);
				for (int imcmc = 0; imcmc < nmcmc; imcmc++)
					myThread[imcmc] = gcnew Thread( ThStart[imcmc] );

				for (int imcmc = 0; imcmc < nmcmc; imcmc++)
					myThread[imcmc]->Start();

				for (int imcmc = 0; imcmc < nmcmc; imcmc++)
					myThread[imcmc]->Join();

				int NTotalSamples = nmcmc * NSimu;
				double ** PooledB = new double*[p];
				for (int i = 0; i < p; i++){
					PooledB[i] = new double[NTotalSamples];
					for (int imcmc = 0; imcmc < nmcmc; imcmc++)
						for (int isimu = 1; isimu <= NSimu; isimu++)
							PooledB[i][NSimu * imcmc + isimu - 1] = myMCMC[imcmc]->paramB[isimu][i];
				}
				for (int i = 0; i < p; i++)
					qSort( PooledB[i], 0, NTotalSamples - 1 );

				/***
				for (int i = 0; i < p; i++){
					fout->WriteLine();
					fout->WriteLine("PooledB[" + i.ToString() + "]...");
					for (int j = 0; j < NTotalSamples; j++)
						if ((j < 10) || (j > NTotalSamples - 10))
							fout->WriteLine(j.ToString() + ":   " + PooledB[i][j].ToString());
				}***/

				//			95% mM (Credible Inteval: CI)
				double * LB = new double[p], * Med = new double[p], * UB = new double[p], * Mean = new double[p];
				for (int i = 0; i < p; i++)
					CalcCIMedMean( PooledB[i], NTotalSamples, LB[i], Med[i], UB[i], Mean[i] );
				
				fout->WriteLine();
				fout->WriteLine(String("Parameter").PadRight(15) 
								+ String("Mean").PadLeft(15) + String("LB").PadLeft(15) 
								+ String("Med").PadLeft(15) + String("UB").PadLeft(15));
				for (int i = 0; i < p; i++)
					fout->WriteLine(("B[" + i.ToString() + "]:")->PadRight(15) + Mean[i].ToString("F5")->PadLeft(15) 
									+ LB[i].ToString("F5")->PadLeft(15) + Med[i].ToString("F5")->PadLeft(15) 
									+ UB[i].ToString("F5")->PadLeft(15));

				do{
					String ^ ck_s;
					do{
						ck_s = fin->ReadLine();
						if (ck_s->Length > 0)
							if(ck_s[0] == '/') break;
					}while(true);

					if(ck_s->Length > 1)
						if((ck_s[1] == 'E') || (ck_s[1] == 'e')) break;
					ck_s = fin->ReadLine();
					double * W = new double[p];
					for (int i = 0; i < p; i++)
						W[i] = double::Parse(SeekStr( ck_s, i ));
					fout->WriteLine();
					fout->WriteLine("Weights...");
					for (int i = 0; i < p; i++)
						fout->Write(W[i].ToString()->PadLeft(7));
					fout->WriteLine();

					double * w_param = new double[NTotalSamples];
					for (int imcmc = 0; imcmc < nmcmc; imcmc++)
						for (int isimu = 1; isimu <= NSimu; isimu++){
							double v = 0.0;
							for (int j = 0; j < p; j++)
								v += W[j] * myMCMC[imcmc]->paramB[isimu][j];
							w_param[NSimu * imcmc + isimu - 1] = v;
						}
					qSort( w_param, 0, NTotalSamples - 1 );
					double CLB, CUB, CMed, CMean;
					CalcCIMedMean( w_param, NTotalSamples, CLB, CMed, CUB, CMean );
					fout->WriteLine("Mean = " + CMean.ToString("F5") 
									+ "     LB = " + CLB.ToString("F5") + "     Median = " + CMed.ToString("F5") 
									+ "     UB = " + CUB.ToString("F5"));

					delete [] w_param;
					delete [] W;
				}while(true);
				
				fin->Close();
				fout->Close();
				MessageBox::Show(saveFileDialog1->FileName + " was saved.");

				this->Close();
			 }
	};
}
